<template>
  <div class="invoice-main">
    <el-dialog :visible.sync="isVisible" title="查看发票" @close="closeDialog">
      <el-scrollbar
        id="resultScroll"
        ref="myScrollbar"
        style="height: 400px; overflow-y: auto; overflow-x: hidden"
      >
        <div class="invoice-item" v-for="item in list" :key="item.id">
          <div class="flex-aic-jcb">
            <div class="invoice-item-text">
              {{ item.titleType == 1 ? "公司名称" : "个人名称" }}：{{
                item.titleName
              }}
            </div>
            <div
              style="
                color: #0a84ff;
                font-size: 12px;
                background: #d9eafa;
                border-radius: 2px;
                padding: 2px 5px;
              "
            >
              {{ item.type == 1 ? "普通发票" : "增值税专用发票" }}-{{
                item.titleType == 1 ? "企业" : "个人"
              }}
            </div>
          </div>
          <div
            class="invoice-item-text"
            v-if="item.titleType == 1 && item.type == 2"
          >
            地址：{{ item.province }}{{ item.city }}{{ item.town
            }}{{ item.address }}
          </div>
          <div
            class="invoice-item-text"
            v-if="item.titleType == 1 && item.type == 2"
          >
            电话：{{ item.phone }}
          </div>
          <div
            class="invoice-item-text"
            v-if="item.titleType == 1 && item.type == 2"
          >
            开户行：{{ item.openBank }}
          </div>
          <div
            class="invoice-item-text"
            v-if="item.titleType == 1 && item.type == 2"
          >
            账号：{{ item.account }}
          </div>
          <div class="invoice-item-text" v-if="item.titleType == 1">
            税号：{{ item.taxCode }}
          </div>
        </div>
        <div
          style="color: #666; font-size: 12px; text-align: center"
          v-if="finished"
        >
          没有更多数据了
        </div>
      </el-scrollbar>
    </el-dialog>
  </div>
</template>
<script type="javascript">
import { userInvoiceList } from "api/userManagement/index";
export default {
  props: ["userId"],
  name: "userManagement",
  components: {},
  data() {
    return {
      list: [],
      finished: false, // 是否已加载全部
      isVisible: false,
      listQuery: {
        page: 1,
        limit: 20,
      },
    };
  },
  mounted() {
    this.isVisible = true;
    this.getInvoiceList();
    // 监听滚动事件
    this.$nextTick(() => {
      $("#resultScroll")[0].addEventListener("scroll", this.handleScroll, true);
    });
  },
  methods: {
    /**
     * 关闭弹窗
     */
    closeDialog() {
      this.$emit("invoiceEvent", false);
    },
    /**
     * 滚动监听
     */
    handleScroll() {
      var that = this;
      var sh = that.$refs["myScrollbar"].$refs["wrap"].scrollHeight; // 滚动条高度
      var st = that.$refs["myScrollbar"].$refs["wrap"].scrollTop; // 滚动条距离顶部的距离
      var ch = that.$refs["myScrollbar"].$refs["wrap"].clientHeight; // 滚动条外容器的高度

      if (st + ch >= sh) {
        //到底了-业务逻辑
        console.log(st);
        this.listQuery.page = this.listQuery.page + 1;
        if (!this.finished) {
          that.getInvoiceList();
        }
      }
    },
    /**
     * 获取发票列表
     */
    getInvoiceList() {
      let _this = this;
      this.listQuery.userId = this.userId;
      console.log(this.listQuery.userId);
      userInvoiceList(this.listQuery).then((response) => {
        if (response.status == 200) {
          let a = response.data.data;
          if (0 == a.length || _this.listQuery.page > response.data.totalPage) {
            _this.finished = true;
            return;
          }
          var e = _this.listQuery.page == 1 ? [] : _this.list;
          a.map(function (item) {
            e.push(item);
          });
          _this.list = e;
        } else {
          this.$notify({
            title: "失败",
            message: response.message,
            type: "error",
            duration: 2000,
          });
        }
      });
    },
  },
};
</script>
<style lang="scss">
.invoice-main {
  .el-scrollbar__wrap {
    overflow-y: auto;
    overflow-x: hidden;
  }
  .invoice-item {
    background: #f5f6fa;
    border: 1px solid #f5f6fa;
    padding: 16px;
    margin-right: 25px;
    margin-bottom: 24px;
    color: #413434;
    font-size: 13px;
    .invoice-item-text {
      line-height: 26px;
    }
  }
}
</style>
